/*
 **  EPIwm
 **  Copyright (C) 1999 Julien Mulot, Thomas Poindessous, Stephane Rault
 **
 **  This program is free software; you can redistribute it and/or modify
 **  it under the terms of the GNU General Public License as published by
 **  the Free Software Foundation; either version 2 of the License, or
 **  (at your option) any later version.
 **
 **  This program is distributed in the hope that it will be useful,
 **  but WITHOUT ANY WARRANTY; without even the implied warranty of
 **  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 **  GNU General Public License for more details.
 **
 **  You should have received a copy of the GNU General Public License
 **  along with this program; if not, write to the Free Software
 **  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 **
 ** epiwm.c
 **
 ** Made by ()
 ** Login   <mulot@epita.fr>
 **
 ** Started on  Mon Dec 28 03:16:49 1998
 ** Last update Tue May 11 00:12:14 1999 Poindessous Thomas
 */

#include "epiwm.h"

const char     *VERSION = "pre-0.4";

void			quit()
{
   t_win_list		**tmp;
   XWindowAttributes	attrib;
   
   tmp = &gl_epiwin.first_win_group_list;
   while (*tmp)
     {
	XGetWindowAttributes(gl_dpy, (*tmp)->p_t_win->parent, &attrib);
	XReparentWindow(gl_dpy, (*tmp)->p_t_win->win, gl_scr_info.root_win,
			attrib.x, attrib.y);
	XMoveWindow(gl_dpy, (*tmp)->p_t_win->win, attrib.x, attrib.y);
	XGetWindowAttributes(gl_dpy, (*tmp)->p_t_win->win, &attrib);
	gl_event.xdestroywindow.window = (*tmp)->p_t_win->parent;
	dest_win();
     }
   exit (0);
}

void add_signals()
{
   signal(SIGINT, quit);
   signal(SIGQUIT, quit);
   signal(SIGKILL, quit);
   signal(SIGTERM, quit);
   /*   signal(SIGSEGV, quit);   */
}

/* Help of command line */
void help()
{
   printf("EPIwm Version %s Usage:\n", VERSION);
   printf("\t-h or --help\tprint this help\n");
   printf("\t-v\t\tshow version\n");
   exit (0);
}

/* options of command line */
void		options(nb_arg, opt)
int             nb_arg;
char		**opt;
{
   while (--nb_arg != 0)
     {
	if (((strncasecmp(opt[nb_arg], "-h", 2)) == 0)
	    || ((strncasecmp(opt[nb_arg], "--help", 6)) == 0))
	  help();
	else if ((strncasecmp(opt[nb_arg], "-d", 2)) == 0)
	  gl_display_name = opt[nb_arg + 1];
	else if ((strncasecmp(opt[nb_arg], "-v", 2)) == 0)
	  {
	     printf("EPIwm Version %s\n", VERSION);
	     exit (0);
	} else if ((strncasecmp(opt[nb_arg - 1], "-d", 2)) != 0)
	  {
	     printf("\nunrecognized option\n\n");
	     help();
	  }
     }
}

int		main(argc, argv)
int             argc;
char		**argv;
{
   gl_display_name = NULL;
   add_signals();
   options(argc, argv);
   init_display();
   init_misc();
   read_config("window");
   read_config("menu");
   initx();
   read_config("icons");
   read_config("key");
   read_config("start");
   handle_events();
   return (1);
}







