/*
 **  EPIwm
 **  Copyright (C) 1999 Julien Mulot, Thomas Poindessous, Stephane Rault
 **
 **  This program is free software; you can redistribute it and/or modify
 **  it under the terms of the GNU General Public License as published by
 **  the Free Software Foundation; either version 2 of the License, or
 **  (at your option) any later version.
 **
 **  This program is distributed in the hope that it will be useful,
 **  but WITHOUT ANY WARRANTY; without even the implied warranty of
 **  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 **  GNU General Public License for more details.
 **
 **  You should have received a copy of the GNU General Public License
 **  along with this program; if not, write to the Free Software
 **  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 **
 ** iconify.c
 **
 ** Made by (Poindessous Thomas)
 ** Login   <poinde_t@epita.fr>
 **
 ** Started on  Wed Mar  3 15:46:08 1999 Poindessous Thomas
 ** Last update Tue May 11 13:57:00 1999 mulot
 */

#include "epiwm.h"

void		iconify_add_elt(win)
t_win		*win;
{
   t_icon_list	*new_icon;
   
   new_icon = malloc(sizeof(t_icon_list));
   new_icon->next = NULL;
   new_icon->win = win;
   if (!(gl_epiwin.current_workspace->first_icon))
     {
	new_icon->prec = NULL;
	gl_epiwin.current_workspace->first_icon = new_icon;
	gl_epiwin.current_workspace->last_icon = new_icon;
	new_icon->nb = 0;
     }
   else
     {
	gl_epiwin.current_workspace->last_icon->next = new_icon;
	new_icon->prec = gl_epiwin.current_workspace->last_icon;
	new_icon->nb = gl_epiwin.current_workspace->last_icon->nb + 1;
	gl_epiwin.current_workspace->last_icon = new_icon;
     }
}

void		iconify_rm_elt(win)
t_win		*win;
{
   t_icon_list	*elt;
   
   elt = iconify_search_elt(win);
   if (elt)
     {
	if (gl_epiwin.current_workspace->first_icon == elt)
	  if (gl_epiwin.current_workspace->last_icon == elt)
	    {
	       gl_epiwin.current_workspace->last_icon = NULL;
	       gl_epiwin.current_workspace->first_icon = NULL;
	    }
	  else
	    {
	       gl_epiwin.current_workspace->first_icon = elt->next;
	       iconify_re_number(gl_epiwin.current_workspace->first_icon);
	       iconify_re_draw(gl_epiwin.current_workspace->first_icon);
	    }
     	else
	  {
	     if (gl_epiwin.current_workspace->last_icon == elt)
	       {
		  gl_epiwin.current_workspace->last_icon = elt->prec;
		  elt->prec->next = elt->next;
	       }
	     else
	       {
		  elt->prec->next = elt->next;
		  elt->next->prec = elt->prec;
	       }
	     iconify_re_number(elt->prec->next);
	     iconify_re_draw(elt->prec->next);
	  }
	free(elt);
	win->iconify_win = 0;
     }
}

t_icon_list	*iconify_search_elt(win)
t_win		*win;
{
   t_icon_list	*tmp;
   
   tmp = gl_epiwin.current_workspace->first_icon;
   if (tmp)
     {
	while ((tmp != gl_epiwin.current_workspace->last_icon) && (tmp->win != win))
	  tmp = tmp->next;
	if (tmp->win == win)
	  return (tmp);
     }
   return (NULL);
}

#ifdef	  __Imlib__
void		draw_icon_image(icon, state)
     Window          icon;
     char		*state;
{
  int		width;
  int		height;
  Pixmap	pixmap;
  
  if (!strcmp("active", state))
    if (!(gl_icon.image = Imlib_load_image(gl_imlib_data,
					   gl_icon.image_active)))
      {
	fprintf(stderr, "cannot load icon active image\n");
	exit (1);
      }
    else
      if (!(gl_icon.image = Imlib_load_image(gl_imlib_data, 
					     gl_icon.image_inactive)))
	{
	  fprintf(stderr, "cannot load icon inactive image\n");
	  exit (1);
	}
   width = gl_icon.image->rgb_width;
   height = gl_icon.image->rgb_height;
   Imlib_render(gl_imlib_data, gl_icon.image, width, height);  
   pixmap = Imlib_move_image(gl_imlib_data, gl_icon.image);
   XSetWindowBackgroundPixmap(gl_dpy, icon, pixmap);  
   XClearWindow(gl_dpy, icon);
}
#endif

void		draw_icon(icon, width, state)
Window          icon;
int             width;
char		*state;
{
   char		*name;
   GC		font_color;
   int		font_direction;
   int		top_size;
   int		bottom_size;
   XCharStruct	dim;
   
   if (!strcmp(state, "active"))
     font_color = gl_icon.font_active;
   else
     font_color = gl_icon.font_inactive;
   XGetIconName(gl_dpy, icon, &name);
   XTextExtents(gl_icon.font, name, strlen(name), &font_direction,
		&top_size, &bottom_size, &dim);
   /*  XDrawString(gl_dpy, icon, font_color,
       (width - text_width) / 2, gl_icon.height / 2,
       name, strlen(name));*/
   XDrawString(gl_dpy, icon, font_color,
	       (width - dim.width) / 2, (gl_icon.height + top_size - 2) / 2, 
	       name, strlen(name));
   free(name);
}

Window			add_iconify_win(group)
t_win			*group;
{
   Window		temp;
   XSetWindowAttributes attr;
   unsigned short	width;
   unsigned short	height;
   unsigned short	height_max;
   
   iconify_add_elt(group);
   height_max = gl_scr_info.dpy_height / gl_icon.height;
   height = gl_epiwin.current_workspace->last_icon->nb % height_max;
   width = gl_epiwin.current_workspace->last_icon->nb / height_max;
   if (group->icon_choose_win == 0)
     {
	temp = XCreateSimpleWindow(gl_dpy,
				   gl_scr_info.root_win,
				   width * gl_icon.width,
				   height * gl_icon.height,
				   gl_icon.width, gl_icon.height, 0,
				   0,
				   gl_icon.color_inactive.pixel);
	attr.event_mask = ButtonPressMask | ButtonReleaseMask
	  | EnterWindowMask | LeaveWindowMask | ExposureMask;
	XChangeWindowAttributes(gl_dpy, temp,
				CWEventMask, &attr);
     }
   else
     temp = group->icon_choose_win;
   return (temp);
}

void		iconify_re_number(list)
t_icon_list	*list;
{
   t_icon_list	*tmp;
   
   tmp = list;
   if (tmp)
     {
	while (tmp != gl_epiwin.current_workspace->last_icon)
	  {
	     tmp->nb--;
	     tmp = tmp->next;
	  }
	tmp->nb--;
     }
}

void			iconify_re_draw(list)
t_icon_list		*list;
{
   t_icon_list		*tmp;
   unsigned short	width;
   unsigned short	height;
   unsigned short	height_max;
   
   tmp = list;
   if (tmp)
     {
	height_max = gl_scr_info.dpy_height / gl_icon.height;
	height = tmp->nb % height_max;
	width = tmp->nb / height_max;
	while (tmp != gl_epiwin.current_workspace->last_icon)
	  {
	     XMoveWindow(gl_dpy, tmp->win->iconify_win,
			 width * gl_icon.width,
			 height * gl_icon.height);
	     tmp = tmp->next;
	     height = tmp->nb % height_max;
	     width = tmp->nb / height_max;
	  }
	XMoveWindow(gl_dpy, tmp->win->iconify_win,
		    width * gl_icon.width,
		    height * gl_icon.height);
     }
}
