/*
 **  EPIwm
 **  Copyright (C) 1999 Julien Mulot, Thomas Poindessous, Stephane Rault
 **
 **  This program is free software; you can redistribute it and/or modify
 **  it under the terms of the GNU General Public License as published by
 **  the Free Software Foundation; either version 2 of the License, or
 **  (at your option) any later version.
 **
 **  This program is distributed in the hope that it will be useful,
 **  but WITHOUT ANY WARRANTY; without even the implied warranty of
 **  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 **  GNU General Public License for more details.
 **
 **  You should have received a copy of the GNU General Public License
 **  along with this program; if not, write to the Free Software
 **  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 **
 ** init.h
 ** 
 ** Made by (Julien Mulot)
 ** Login   <mulot@epita.fr>
 ** 
 ** Started on  Wed Jan 27 20:26:28 1999 Julien Mulot
 ** Last update Thu May  6 22:36:01 1999 Poindessous Thomas
 */

#ifndef   __INIT_H__
#define   __INIT_H__
#include "screen.h"
#include <stdio.h>
#include <X11/Xlib.h>

void		capture_windows();
char            *cut_str(char *, char *);
XErrorHandler	handler(Display *, XErrorEvent *);
char		*index_file(char *, int);
void		init_color(char *,char *);
void		init_config(FILE *, char *);
void		init_cursor();
void		init_display();
void		init_event();
void		init_font_color(GC *, char *);
void		init_gc();
void		init_image(char *, char *);
void		init_misc();
void		initx();
void		init_atoms();
void		read_config(char *);

char		*gl_display_name;
int		gl_parent_pid;
Display		*gl_dpy;
GC		gc_black;
GC		gc_dark;
GC		gc_light;
GC		gc_medium;
GC		gc_white;
GC		gc_xor;
XEvent		gl_event;
#ifdef	  __Imlib__
ImlibData	*gl_imlib_data;
#endif

#endif /* __INIT_H__ */
