/*
**  EPIwm
**  Copyright (C) 1999 Julien Mulot, Thomas Poindessous, Stephane Rault
**
**  This program is free software; you can redistribute it and/or modify
**  it under the terms of the GNU General Public License as published by
**  the Free Software Foundation; either version 2 of the License, or
**  (at your option) any later version.
**
**  This program is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**  GNU General Public License for more details.
**
**  You should have received a copy of the GNU General Public License
**  along with this program; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
**
** menu.h
** 
** Made by (Julien Mulot)
** Login   <mulot@epita.fr>
** 
** Started on  Thu Feb 18 17:05:48 1999 Julien Mulot
 ** Last update Tue May 11 02:50:36 1999 Julien Mulot
*/

#ifndef   __MENU_H__
#define   __MENU_H__
#include "epiwm.h"

#define MENU_MINI_WIDTH 100
#define MENU_SPACE 27

typedef struct		s_menu
{
  int			width;
  int			task_width;
  char			**current_elt;
  char			**current_menu;
  char			*lngst_str;
  char			*lngst_str_prop;
  char			*image_name;
  char			grad_type;
  char			auto_menu;
  char			here_prop;
  char			here_task;
  char			highlight;
  Window		*current_task;
  Window		menu_prop;
  Window		menu_task;
  Pixel			*pixels;
  XFontStruct		*font;
  GC			font_inactive;
  GC			font_active;
  XColor		color;
  XColor		color_highlight;
#ifdef	  __Imlib__
  ImlibImage		*image;
#endif
}			t_menu;

typedef	struct		s_menu_prop
{
  char			*elt;
  char			*cmd;
  struct s_menu_prop	*next_elt;
}			t_menu_prop;

typedef	struct		s_menu_task
{
  char			*elt;
  char			*cmd;
  struct s_menu_task	*next_elt;
}			t_menu_task;

typedef	struct		s_menu_apps
{
  char			*elt;
  char			*cmd;
  struct s_menu_apps	*next_elt;
  struct s_menu_apps	*menu;
}			t_menu_apps;

typedef struct		s_menu_pos
{
  char			*menu_name;
  char			here;
  char			stick;
  short			nb_elt;
  short			height;
  short			win_pos;
  Window   		win;
  t_menu_apps		**pos;
  struct s_menu_pos	*next;
}			t_menu_pos;

void	add_menu_elt(t_menu_pos **, char *, char *);
void	add_menu_sub(t_menu_apps **, t_menu_pos **, char *);
void	destroy_menu(t_menu_pos **, char *);
void	draw_menu(t_menu_apps **, t_menu_pos **);
void	draw_menu_task();
void	draw_triangle(Window, int, int, char *);
char	*extract_name(char *);
char	*extract_str(char *, char *);
void	destroy_other_menus(t_menu_apps *, char *);
void	elt_detect(char *, char *);
void	menu_apps(char *, int, int);
void	menu_click(t_menu_pos *, int, int, unsigned int);
void	menu_build(FILE *);
void	menu_detect(char **, char *, char *);
void	menu_display(Window, int, int, unsigned int);
void	menu_move(t_menu_pos *, int, int);
void	menu_prop(Window, int, int);
void	menu_task(int, int);
void	menu_task_click(int, int);
void	menu_task_move(int, int);
void	set_dim_menu();
void	sub_menu_detect(char *, char *);

t_menu_apps	*gl_menu_apps;
t_menu_prop	*gl_menu_prop;
t_menu_task	*gl_menu_task;
t_menu		gl_menu;
t_menu_pos	*menu_pos;
#endif /* __MENU_H__ */
