/*
 **  EPIwm
 **  Copyright (C) 1999 Julien Mulot, Thomas Poindessous, Stephane Rault
 **
 **  This program is free software; you can redistribute it and/or modify
 **  it under the terms of the GNU General Public License as published by
 **  the Free Software Foundation; either version 2 of the License, or
 **  (at your option) any later version.
 **
 **  This program is distributed in the hope that it will be useful,
 **  but WITHOUT ANY WARRANTY; without even the implied warranty of
 **  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 **  GNU General Public License for more details.
 **
 **  You should have received a copy of the GNU General Public License
 **  along with this program; if not, write to the Free Software
 **  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 **
 ** mouse_functions.c
 ** 
 ** Made by (Poindessous Thomas)
 ** Login   <poinde_t@epita.fr>
 ** 
 ** Started on  Sun Apr  4 15:48:03 1999 Poindessous Thomas
 ** Last update Tue May 18 16:42:59 1999 Thomas Poindessous
 */

#include "epiwm.h"

void			mouse_motion_notify(wg_tmp)
t_win			*wg_tmp;
{
   int			x_root;
   int			y_root;
   t_mouse_move_win	list;
   XWindowAttributes	attrib;
   
   list.button = &gl_event.xbutton;
   list.temp = wg_tmp;
   /*wg_tmp = search_elt(gl_win_move.win); */
   if (wg_tmp)
     {
	if (gl_epiwin.is_window_changing)
	  {
	     if ((wg_tmp->titlebar_win == gl_event.xmotion.window) &&
		 ((Button1Mask == (list.button->state & Button1Mask))))
	       {
		   x_root = gl_event.xmotion.x_root - gl_win_move.win_x;
		   y_root = gl_event.xmotion.y_root - gl_win_move.win_y;
		   clientSetState(wg_tmp, WithdrawnState);
		   if (gl_epiwin.opaque_move)
		     {
			/* XClearArea serait mieux */
			XClearWindow(gl_dpy, gl_scr_info.root_win);
			XGetWindowAttributes(gl_dpy, wg_tmp->parent, &attrib);
			XDrawRectangle(gl_dpy, gl_scr_info.root_win, gc_black,
				       x_root, y_root,
				       attrib.width + attrib.border_width,
				       attrib.height + attrib.border_width);
		     }
		   else
		     XMoveWindow(gl_dpy, wg_tmp->parent, x_root, y_root);
		   mouse_on_border_notify();
		}
	     else if (wg_tmp->border_frame == gl_win_move.win)
	       {
		  win_resize_all(wg_tmp);
		  mouse_on_border_notify();
	       }
	  }
	else
	  {
	     if (wg_tmp->border_frame == gl_event.xmotion.window)
	       set_border_cursor(wg_tmp->border_frame);
	     if (wg_tmp->titlebar_win == gl_event.xmotion.window)
	       set_titlebar_cursor(wg_tmp->titlebar_win);
	     mouse_on_border_notify();
	  }
     }
}

void			win_max_width(wg_tmp)
t_win			*wg_tmp;
{
   XWindowAttributes	attrib;
   
   if (wg_tmp->is_max_width)
     {
	if (wg_tmp->is_max ==0)
	  {
	     if (wg_tmp->is_shade)
	       {
		  XGetWindowAttributes(gl_dpy, wg_tmp->parent, &attrib);
		  window_group_resize(wg_tmp, wg_tmp->win_x, wg_tmp->win_y,
				      wg_tmp->win_width,
				      attrib.height);
		  XGetWindowAttributes(gl_dpy, wg_tmp->win, &attrib);
		  wg_tmp->shade_width = wg_tmp->win_width
		    - 2*(attrib.border_width + gl_epiwin.bf_border +
			 gl_epiwin.border_width);
	       }
	     else
	       window_group_resize(wg_tmp, wg_tmp->win_x, wg_tmp->win_y,
				   wg_tmp->win_width,
				   wg_tmp->win_height);
	     send_configure_notify(wg_tmp);
	  }
	wg_tmp->is_max_width = 0;
     }
   else
     {
	if (!(wg_tmp->is_max_height || wg_tmp->is_shade || wg_tmp->is_max))
	  {
	     XGetWindowAttributes(gl_dpy, wg_tmp->parent, &attrib);
	     wg_tmp->win_x = attrib.x;
	     wg_tmp->win_y = attrib.y;
	     wg_tmp->win_width = attrib.width;
	     wg_tmp->win_height = attrib.height;
	  }
	if (wg_tmp->is_max == 0) 	         
	  {
	     XGetWindowAttributes(gl_dpy, wg_tmp->parent, &attrib);
	     window_group_resize(wg_tmp, 0, attrib.y,
				 gl_scr_info.dpy_width - 2*attrib.border_width,
				 attrib.height);	  
	     send_configure_notify(wg_tmp);
	  }
	wg_tmp->is_max_width = 1;
     }
}

void			win_max_height(wg_tmp)
t_win			*wg_tmp;
{
   XWindowAttributes	attrib;
   
   if (wg_tmp->is_max_height)
     {
	if (wg_tmp->is_max ==0)
	  {
	     if (wg_tmp->is_shade)
	       {
		  XGetWindowAttributes(gl_dpy, wg_tmp->parent, &attrib);
		  window_group_resize(wg_tmp, wg_tmp->win_x, wg_tmp->win_y,
				      attrib.width,
				      attrib.height);
	       }
	     else
	       window_group_resize(wg_tmp, wg_tmp->win_x, wg_tmp->win_y,
				   wg_tmp->win_width,
				   wg_tmp->win_height);
	     send_configure_notify(wg_tmp);
	  }
	wg_tmp->is_max_height = 0;
     }
   else
     {
	if (!(wg_tmp->is_max_width || wg_tmp->is_shade || wg_tmp->is_max))
	  {
	     XGetWindowAttributes(gl_dpy, wg_tmp->parent, &attrib);
	     wg_tmp->win_x = attrib.x;
	     wg_tmp->win_y = attrib.y;
	     wg_tmp->win_width = attrib.width;
	     wg_tmp->win_height = attrib.height;
	  }
	if (wg_tmp->is_max == 0) 	         
	  {
	     XGetWindowAttributes(gl_dpy, wg_tmp->parent, &attrib);
	     if (wg_tmp->is_shade)
	       XMoveWindow(gl_dpy, wg_tmp->parent, attrib.x, 0);
	     else
	       window_group_resize(wg_tmp, attrib.x, 0, attrib.width,
				   gl_scr_info.dpy_height
				   - 2*attrib.border_width);
	     send_configure_notify(wg_tmp);
	  }
	wg_tmp->is_max_height = 1;
     }
}

void	win_resize_all(wg_tmp)
t_win	*wg_tmp;		
{
   int	width_inc;
   int	height_inc;
   
   width_inc = wg_tmp->hints.width_inc;
   height_inc = wg_tmp->hints.height_inc;   
   if (gl_win_move.win_x <= gl_epiwin.border_width)
     if (gl_win_move.win_y <= gl_win_move.height - gl_epiwin.border_width)
       win_resize_left(wg_tmp, width_inc, height_inc);
     else
       win_resize_down_left(wg_tmp, width_inc, height_inc);
   else if (gl_win_move.win_x >= gl_win_move.width - gl_epiwin.border_width)
     if (gl_win_move.win_y <= gl_win_move.height - gl_epiwin.border_width)
       win_resize_right(wg_tmp, width_inc, height_inc);
     else
       win_resize_down_right(wg_tmp, width_inc, height_inc);
   else if (gl_win_move.win_x > gl_epiwin.border_width &&
	    gl_win_move.win_y >= gl_win_move.height - gl_epiwin.border_width &&
	    gl_win_move.win_x < gl_win_move.width - gl_epiwin.border_width)
     win_resize_down(wg_tmp, width_inc, height_inc);
   else 
     return ;
   if (wg_tmp->is_win_shape)
     add_shape(wg_tmp->win, wg_tmp->parent);
   send_configure_notify(wg_tmp);
}

void	win_resize_left(wg_tmp, width_inc, height_inc)
t_win	*wg_tmp;
int	width_inc;
int	height_inc;
{
   XWindowAttributes	attrib;
   int			width;
   
   XGetWindowAttributes(gl_dpy, wg_tmp->parent, &attrib);
   width = (((int) (attrib.x - gl_event.xmotion.x_root))
	    / width_inc) * width_inc;
   if (width == 0)
     return ;
   if (attrib.width + width >= 1)
     window_group_resize(wg_tmp, attrib.x - width, attrib.y,
			 attrib.width + width, attrib.height);
   else
     window_group_resize(wg_tmp, attrib.x + attrib.width, attrib.y,
			 1, attrib.height);
}

void	win_resize_right(wg_tmp, width_inc, height_inc)
t_win	*wg_tmp;
int	width_inc;
int	height_inc;
{
   XWindowAttributes	attrib;
   int			width;
   
   XGetWindowAttributes(gl_dpy, wg_tmp->parent, &attrib);
   width = (((int) (gl_event.xmotion.x_root - attrib.x
		    - attrib.width))
	    / width_inc) * width_inc;
   if (width == 0)
     return ;
   if (attrib.width + width >= 1)
     window_group_resize(wg_tmp, attrib.x, attrib.y,
			 attrib.width + width, attrib.height);
   else
     window_group_resize(wg_tmp, attrib.x, attrib.y, 1, attrib.height);
}

void	win_resize_up(wg_tmp, width_inc, height_inc)
t_win	*wg_tmp;
int	width_inc;
int	height_inc;
{
   XWindowAttributes	attrib;
   int			height;
   
   XGetWindowAttributes(gl_dpy, wg_tmp->parent, &attrib);
   height = (((int) (attrib.y - gl_event.xmotion.y_root))
	     / height_inc) * height_inc;
   if (height == 0)
     return ;
   if (attrib.height + height >= 1)
     window_group_resize(wg_tmp, attrib.x, attrib.y - height,
			 attrib.width, attrib.height + height);
   else
     window_group_resize(wg_tmp, attrib.x, attrib.y + attrib.height
			 - wg_tmp->hints.min_height
			 + 2*(wg_tmp->win_border + gl_epiwin.border_height
			      + gl_epiwin.titlebar.border)
			 + gl_epiwin.titlebar.height + gl_epiwin.bf_border,
			 attrib.width, 1);   
}

void	win_resize_down(wg_tmp, width_inc, height_inc)
t_win	*wg_tmp;
int	width_inc;
int	height_inc;
{
   XWindowAttributes	attrib;
   int			height;
   
   XGetWindowAttributes(gl_dpy, wg_tmp->parent, &attrib);
   height = (((int) (gl_event.xmotion.y_root - attrib.y - attrib.height))
	     / height_inc) * height_inc;
   if (height == 0)
     return ;
   if (attrib.height + height >= 1)
     window_group_resize(wg_tmp, attrib.x, attrib.y,
			 attrib.width, attrib.height + height);
   else
     window_group_resize(wg_tmp, attrib.x, attrib.y, attrib.width, 1);
}

void	win_resize_up_left(wg_tmp, width_inc, height_inc)
t_win	*wg_tmp;
int	width_inc;
int	height_inc;
{
   XWindowAttributes	attrib;
   int			height;
   int			width;
   
   XGetWindowAttributes(gl_dpy, wg_tmp->parent, &attrib);
   height = (((int) (attrib.y - gl_event.xmotion.y_root))
	     / height_inc) * height_inc;
   width = (((int) (attrib.x - gl_event.xmotion.x_root))
	    / width_inc) * width_inc;
   if (height == 0 && width == 0)
     return ;
   if (attrib.width + width >= 1 && attrib.height + height >= 1)
     window_group_resize(wg_tmp, attrib.x - width,  attrib.y - height,
			 attrib.width + width, attrib.height + height);
   else if (attrib.width + width < 1 && attrib.height + height >= 1)
     window_group_resize(wg_tmp, attrib.x + attrib.width, attrib.y - height,
			 1, attrib.height + height);
   else if (attrib.width + width >= 1 && attrib.height + height < 1)
     window_group_resize(wg_tmp, attrib.x - width, attrib.y + attrib.height
			 - wg_tmp->hints.min_height
			 + 2*(wg_tmp->win_border + gl_epiwin.border_height
			      + gl_epiwin.titlebar.border)
			 + gl_epiwin.titlebar.height + gl_epiwin.bf_border,
			 attrib.width + width, 1);
   else if (attrib.width + width < 1 && attrib.height + height < 1)
     window_group_resize(wg_tmp, attrib.x + attrib.width,
			 attrib.y + attrib.height
			 - wg_tmp->hints.min_height
			 + 2*(wg_tmp->win_border + gl_epiwin.border_height
			      + gl_epiwin.titlebar.border)
			 + gl_epiwin.titlebar.height + gl_epiwin.bf_border,
			 1, 1);   
}

void	win_resize_up_right(wg_tmp, width_inc, height_inc)
t_win	*wg_tmp;
int	width_inc;
int	height_inc;
{
   
}

void	win_resize_down_left(wg_tmp, width_inc, height_inc)
t_win	*wg_tmp;
int	width_inc;
int	height_inc;
{
   XWindowAttributes	attrib;
   int			width;
   int			height;
   
   XGetWindowAttributes(gl_dpy, wg_tmp->parent, &attrib);
   width = (((int) (attrib.x - gl_event.xmotion.x_root))
	    / width_inc) * width_inc;
   height = (((int) (gl_event.xmotion.y_root - attrib.y - attrib.height))
	     / height_inc) * height_inc;
   if (width == 0 && height == 0)
     return ;
   if (attrib.width + width >= 1 && attrib.height + height >= 1)
     window_group_resize(wg_tmp, attrib.x - width, attrib.y,
			 attrib.width + width, attrib.height + height);
   else if (attrib.width + width < 1 && attrib.height + height >= 1)
     window_group_resize(wg_tmp, attrib.x + attrib.width, attrib.y,
			 1, attrib.height + height);
   else if (attrib.width + width >= 1 && attrib.height + height < 1)
     window_group_resize(wg_tmp, attrib.x - width, attrib.y,
			 attrib.width + width, 1);
   else if (attrib.width + width < 1 && attrib.height + height < 1)
     window_group_resize(wg_tmp, attrib.x + attrib.width, attrib.y,
			 1, 1);   
}

void	win_resize_down_right(wg_tmp, width_inc, height_inc)
t_win	*wg_tmp;
int	width_inc;
int	height_inc;
{
   XWindowAttributes	attrib;
   int			height;
   int			width;
   
   XGetWindowAttributes(gl_dpy, wg_tmp->parent, &attrib);
   height = (((int) (gl_event.xmotion.y_root - attrib.y - attrib.height))
	     / height_inc) * height_inc;
   width = (((int) (gl_event.xmotion.x_root - attrib.x
		    - attrib.width))
	    / width_inc) * width_inc;
   if (height == 0 && width == 0)
     return ;
   if (attrib.height + height >= 1 && attrib.width + width >= 1)
     window_group_resize(wg_tmp, attrib.x, attrib.y,
			 attrib.width + width, attrib.height + height);
   else if (attrib.height + height >= 1 && attrib.width + width < 1)
     window_group_resize(wg_tmp, attrib.x, attrib.y,
			 1, attrib.height + height);
   else if (attrib.height + height < 1 && attrib.width + width >= 1)
     window_group_resize(wg_tmp, attrib.x, attrib.y,
			 attrib.width + width, 1);
   else if (attrib.height + height < 1 && attrib.width + width < 1)
          window_group_resize(wg_tmp, attrib.x, attrib.y,
			      1, 1);   
}
