/*
 **  EPIwm
 **  Copyright (C) 1999 Julien Mulot, Thomas Poindessous, Stephane Rault
 **
 **  This program is free software; you can redistribute it and/or modify
 **  it under the terms of the GNU General Public License as published by
 **  the Free Software Foundation; either version 2 of the License, or
 **  (at your option) any later version.
 **
 **  This program is distributed in the hope that it will be useful,
 **  but WITHOUT ANY WARRANTY; without even the implied warranty of
 **  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 **  GNU General Public License for more details.
 **
 **  You should have received a copy of the GNU General Public License
 **  along with this program; if not, write to the Free Software
 **  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 **
 ** window_events.c
 ** 
 ** Made by (Poindessous Thomas)
 ** Login   <poinde_t@epita.fr>
 ** 
 ** Started on  Mon Feb 22 15:30:57 1999 Poindessous Thomas
 ** Last update Tue May 11 00:14:38 1999 Poindessous Thomas
 */

#include "epiwm.h"

void			dest_win()
{
   Window		win;  
   t_win		*temp;
   
   win = gl_event.xdestroywindow.window;
   temp = search_elt(win);
   if (temp)
     {
	if (temp->has_parent)	       
	  XDestroyWindow(gl_dpy,temp->parent);	  
	if (temp->iconify_win)
	  {
	     XDestroyWindow(gl_dpy, temp->iconify_win);	  
	     iconify_rm_elt(temp);
	  }
	/*
	   ww_temp = workspace_window_search(gl_epiwin.current_workspace, temp);
	   if (ww_temp)
	   workspace_window_remove(gl_epiwin.current_workspace, ww_temp);
	   else
	   {
	   w_temp = gl_epiwin.first_workspace;
	   while (w_temp)
	   {
	   ww_temp = workspace_window_search(w_temp, temp);
	   if (ww_temp)
	   {
	   workspace_window_remove(w_temp, ww_temp);
	   w_temp = NULL;
	   }
	   else
	   w_temp = w_temp->next;
	   }
	   }
	   */
	remove_elt(temp->win);
	if (temp == gl_epiwin.current)
	  gl_epiwin.current = NULL;
     }
}

void			resize_win()
{
   Window		win;
   int			width;
   int			height;  
   t_win		*temp;
   XWindowAttributes	attrib;
   
   win = gl_event.xresizerequest.window;
   width = gl_event.xresizerequest.width;
   height = gl_event.xresizerequest.height;
   temp	= search_elt(win);
   if (temp)
     {
	if (temp->iconify_win != win &&
	    temp->titlebar_win != win)
	  {
	     XGetWindowAttributes(gl_dpy, temp->parent, &attrib);
	     window_group_resize(temp,
				 attrib.x,
				 attrib.y,
				 width + (gl_epiwin.border_width +
					  temp->win_border +
					  gl_epiwin.bf_border)*2,
				 height + (gl_epiwin.border_height +
					   temp->win_border +
					   gl_epiwin.titlebar.border)*2
				 + gl_epiwin.titlebar.height
				 + gl_epiwin.bf_border);
	     
	     /*
		XGetWindowAttributes(gl_dpy, temp->win, &attrib);
		XResizeWindow(gl_dpy, temp->win, width, height);
		if (temp->has_parent)
		{
		if (((width + (gl_epiwin.border_width +
		attrib.border_width +
		gl_epiwin.bf_border)*2) > 0) &&
		((height + (gl_epiwin.border_height +
		attrib.border_width +
		gl_epiwin.titlebar.border)*2
		+ gl_epiwin.titlebar.height
		+ gl_epiwin.bf_border) > 0))
		XResizeWindow(gl_dpy, temp->parent, 
		width + (gl_epiwin.border_width +
		attrib.border_width +
		gl_epiwin.bf_border)*2,
		height + (gl_epiwin.border_height +
		attrib.border_width +
		gl_epiwin.titlebar.border)*2
		+ gl_epiwin.titlebar.height
		+ gl_epiwin.bf_border);
		window_group_resize(temp);
		*/
	     send_configure_notify(temp);
	  }
     }
}

void				configure_win()
{
   XConfigureRequestEvent	*stct;
   t_win			*ewin;
   XWindowChanges		win_conf;
   unsigned int			value_mask;
   XWindowAttributes		attrib;
   
   stct = &gl_event.xconfigurerequest;
   ewin = search_elt(stct->window);
   value_mask = 0;
   if (ewin)
     if (ewin->win == stct->window)  
       {
	  if (stct->value_mask & CWX)
	    value_mask |= CWX ;
	  if (stct->value_mask & CWY)
	    value_mask |= CWY ;
	  if (stct->value_mask & CWWidth)
	    value_mask |= CWWidth ;
	  if (stct->value_mask & CWHeight)
	    value_mask |= CWHeight ;
	  if (value_mask)
	    {
	       XGetWindowAttributes(gl_dpy, ewin->win, &attrib);
	       win_conf.x = attrib.x;
	       win_conf.y = attrib.y;
	       win_conf.width = stct->width;
	       win_conf.height = stct->height;
	       win_conf.border_width = stct->border_width;
	       if ((value_mask | CWWidth) || (value_mask | CWHeight))
		 {
		    if (((value_mask | CWX) || (value_mask | CWY)) &&
			((stct->x != gl_epiwin.border_width) ||
			 (stct->y != gl_epiwin.border_height)))
		      {
			 window_group_resize(ewin,			     
					     stct->x - stct->border_width -
					     gl_epiwin.border_width -
					     gl_epiwin.bf_border,
					     stct->y - stct->border_width -
					     gl_epiwin.border_height -
					     gl_epiwin.titlebar.height -
					     gl_epiwin.titlebar.border*2,
					     win_conf.width +
					     (stct->border_width +
					      gl_epiwin.border_width +
					      gl_epiwin.bf_border)*2,
					     win_conf.height +
					     (stct->border_width +
					      gl_epiwin.border_width +
					      gl_epiwin.titlebar.border)*2 +
					     gl_epiwin.titlebar.height +
					     gl_epiwin.bf_border);
		      }
		    else
		      {
			 XGetWindowAttributes(gl_dpy, ewin->parent, &attrib);
			 window_group_resize(ewin, attrib.x, attrib.y,
					     win_conf.width +
					     (stct->border_width +
					      gl_epiwin.border_width +
					      gl_epiwin.bf_border)*2,
					     win_conf.height +
					     (stct->border_width +
					      gl_epiwin.border_width +
					      gl_epiwin.titlebar.border)*2 +
					     gl_epiwin.titlebar.height +
					     gl_epiwin.bf_border);
		      }
		    XConfigureWindow(gl_dpy, ewin->win,
				     value_mask, &win_conf);
		    gl_event.xmap.window = ewin->win;
		    map_win();
		 }
	       else
		 if (((value_mask | CWX) || (value_mask | CWY)) &&
		     ((stct->x != gl_epiwin.border_width) ||
		      (stct->y != gl_epiwin.border_height)))
		   {
		      XMoveWindow(gl_dpy, ewin->parent,
				  stct->x - stct->border_width -
				  gl_epiwin.border_width -
				  gl_epiwin.bf_border,
				  stct->y - stct->border_width -
				  gl_epiwin.border_height -
				  gl_epiwin.titlebar.height -
				  gl_epiwin.titlebar.border*2);
		      XConfigureWindow(gl_dpy, ewin->win,
				       value_mask, &win_conf);
		      gl_event.xmap.window = ewin->win;
		      map_win();
		   }
	       
	    }
       }
}

void			map_win()
{
   Window		win;  
   t_win		*ewin;
      
   win	= gl_event.xmap.window;
   ewin	= search_elt(win);
   if (ewin)
     {
	if (ewin->iconify_win != win)
	  {
	     window_group_map(ewin);
	     clientSetState(ewin, NormalState);
	     /*
		ww_tmp = workspace_window_search(gl_epiwin.current_workspace,
		ewin);
		if (ww_tmp)
		{
		ww_tmp->is_win_mapped = 1;
		ww_tmp->is_icon_mapped = 0;
		}
		ewin->mapped = 1;
		*/
	  }
     }
   else     
     create_win(win);   
}

void			unmap_win()
{
   Window		parent;
   Window		win;       
   t_win		*ewin;
   XEvent		ev;
   
   parent= gl_event.xunmap.event;
   win	= gl_event.xunmap.window;
   ewin	= search_elt(win);
   if (ewin)
     if ((ewin->iconify_win != win)) /* && ewin->mapped)	         */
       if (ewin->has_parent)
	 {
	    /*
	     ** je change is_win_mapped que si cuurent_wor = le work de la win
	     */
	    if (XCheckTypedWindowEvent(gl_dpy, ewin->win, DestroyNotify, &ev))
	      {
		 gl_event.xdestroywindow.window = ewin->parent;
		 dest_win();
		 return ;
	      }
	    XUnmapWindow(gl_dpy,ewin->parent);
	    clientSetState(ewin, WithdrawnState);
	    /*
	       ww_temp = workspace_window_search(gl_epiwin.current_workspace,
	       ewin);
	       if (ww_temp)
	       ww_temp->is_win_mapped = 0;
	       */
	    /*
	       else
	       {
	       w_temp = gl_epiwin.first_workspace;
	       while (w_temp)
	       {
	       ww_temp = workspace_window_search(w_temp, ewin);
	       if (ww_temp)
	       {
	       ww_temp->is_win_mapped = 0;
	       w_temp = NULL;
	       }
	       else
	       w_temp = w_temp->next;
	       }
	       }
	       */
	 }
}

void			prop_not()
{
   t_win		*ewin;
   XSizeHints		*hints_return;
   long			*supplied_return;
   Atom			property;
   
   ewin = search_elt(gl_event.xproperty.window);
   if (ewin)
     {
	if (gl_event.xproperty.atom == XA_WM_NORMAL_HINTS)
	  {
	     property = XA_WM_SIZE_HINTS;
	     XGetWMSizeHints(gl_dpy, ewin->win,
			     hints_return, supplied_return, property);
	  }
     }
}

void			map_req()
{
   Window		win;  
   t_win		*ewin;
   
   win	= gl_event.xmaprequest.window;
   ewin	= search_elt(win);
   if (ewin)
     {
	if (ewin->iconify_win != win)
	  {
	     if (ewin->iconify_win)
	       {
		  XDestroyWindow(gl_dpy, ewin->iconify_win);
		  iconify_rm_elt(ewin);
	       }
	     window_group_map(ewin);
	     XRaiseWindow(gl_dpy, ewin->parent);
	     clientSetState(ewin, NormalState);
	     /*
		ww_tmp = workspace_window_search(gl_epiwin.current_workspace,
		ewin);
		if (ww_tmp)
		{
		ww_tmp->is_win_mapped = 1;
		ww_tmp->is_icon_mapped = 0;
		}
		ewin->mapped = 1;
		*/
	  }
     }
   else     
     create_win(win);
}
