/*
 **  EPIwm
 **  Copyright (C) 1999 Julien Mulot, Thomas Poindessous, Stephane Rault
 **
 **  This program is free software; you can redistribute it and/or modify
 **  it under the terms of the GNU General Public License as published by
 **  the Free Software Foundation; either version 2 of the License, or
 **  (at your option) any later version.
 **
 **  This program is distributed in the hope that it will be useful,
 **  but WITHOUT ANY WARRANTY; without even the implied warranty of
 **  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 **  GNU General Public License for more details.
 **
 **  You should have received a copy of the GNU General Public License
 **  along with this program; if not, write to the Free Software
 **  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 **
 ** workspace.c
 ** 
 ** Made by (Poindessous Thomas)
 ** Login   <poinde_t@epita.fr>
 ** 
 ** Started on  Fri Apr  2 15:29:54 1999 Poindessous Thomas
 ** Last update Tue May 11 00:11:44 1999 Poindessous Thomas
 */

#include "epiwm.h"

void	add_first_workspace()
{
   gl_epiwin.first_workspace = (t_workspace *)malloc(sizeof(t_workspace));
   gl_epiwin.first_workspace->prev = NULL;
   gl_epiwin.first_workspace->next = NULL;
   gl_epiwin.first_workspace->nb = 1;
   gl_epiwin.first_workspace->workspace_window = NULL;
   gl_epiwin.first_workspace->first_icon = NULL;
   gl_epiwin.first_workspace->last_icon = NULL;
   gl_epiwin.current_workspace = gl_epiwin.first_workspace;
}

void	add_another_workspace()
{
   workspace_new();
}

void			change_current_workspace(new_workspace)
t_workspace		*new_workspace;
{
   t_workspace_window	*ww_temp;
   
   ww_temp = gl_epiwin.current_workspace->workspace_window;
   while (ww_temp)
     {
	workspace_window_unmap(ww_temp);
	ww_temp = ww_temp->next;
     }
   gl_epiwin.current_workspace = new_workspace;
   ww_temp = gl_epiwin.current_workspace->workspace_window;
   while (ww_temp)
     {
	workspace_window_map(ww_temp);
	ww_temp = ww_temp->next;
     }
}

void			workspace_window_unmap(ww_temp)
t_workspace_window	*ww_temp;
{
   if (ww_temp->is_win_mapped)     
     XUnmapWindow(gl_dpy, ww_temp->window_group->parent);
   else if (ww_temp->is_icon_mapped)
     XUnmapWindow(gl_dpy, ww_temp->window_group->iconify_win);
}

void			workspace_window_map(ww_temp)
t_workspace_window	*ww_temp;
{
   if (ww_temp->is_win_mapped)
     XMapWindow(gl_dpy, ww_temp->window_group->parent);
   else if (ww_temp->is_icon_mapped)
     XMapWindow(gl_dpy, ww_temp->window_group->iconify_win);
}


void		send_window_to_workspace(window, workspace)
t_win		*window;
t_workspace	*workspace;
{  
   if (workspace != gl_epiwin.current_workspace)
     XMoveWindow(gl_dpy, window->parent,
		 window->win_x +
		 (workspace->nb - gl_epiwin.current_workspace->nb) *
		 gl_scr_info.dpy_width, window->win_y);   
}

t_workspace		*search_window_in_all_workspaces(window)
t_win			*window;
{
   t_workspace		*workspace;
   t_workspace_window	*return_value;
   
   return_value = NULL;
   workspace = gl_epiwin.first_workspace;
   while (return_value == NULL)
     {
	return_value = workspace_window_search(workspace, window);
	if (workspace->next && !(return_value))
	  workspace = workspace->next;
     }
   return (workspace);
}






