/*
 **  EPIwm
 **  Copyright (C) 1999 Julien Mulot, Thomas Poindessous, Stephane Rault
 **
 **  This program is free software; you can redistribute it and/or modify
 **  it under the terms of the GNU General Public License as published by
 **  the Free Software Foundation; either version 2 of the License, or
 **  (at your option) any later version.
 **
 **  This program is distributed in the hope that it will be useful,
 **  but WITHOUT ANY WARRANTY; without even the implied warranty of
 **  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 **  GNU General Public License for more details.
 **
 **  You should have received a copy of the GNU General Public License
 **  along with this program; if not, write to the Free Software
 **  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 **
 ** workspace_list.c
 ** 
 ** Made by (Stephane RAULT)
 ** Login   <rault_s@epita.fr>
 ** 
 ** Started on  Wed Mar 31 17:51:34 1999 Stephane RAULT
 ** Last update Sun May  9 16:32:11 1999 Poindessous Thomas
 */

#include "epiwm.h"

/*
 ** Create a new list and init it to NULL
 */
void		workspace_new()
{
   t_workspace	*new_workspace;
   t_workspace	*last;
   
   new_workspace = (t_workspace *)malloc(sizeof(t_workspace));
   new_workspace->workspace_window = NULL;
   new_workspace->next = NULL;
   new_workspace->prev = NULL;
   new_workspace->first_icon = NULL;
   new_workspace->last_icon = NULL;
   last = gl_epiwin.first_workspace;
   while (last->next)
      last = last->next;
   last->next = new_workspace;
   new_workspace->prev = last;
   new_workspace->nb = last->nb + 1;
}

/*
 ** Free the workspace
 */
void		workspace_free()
{
   t_workspace	*tmp;
   
   tmp = gl_epiwin.first_workspace;
   if (tmp->next)
      tmp = tmp->next;
   while (tmp->next)
   {
      free(tmp->prev);		/* free_workspace_win */
      tmp = tmp->next;
   }
   free(tmp);			/* free_workspace_win */
}

/*
 ** Remove an element from the workspace (search by data)
 */
void		workspace_remove(workspace)
t_workspace	*workspace;
{
   t_workspace	*tmp;
   
   tmp = gl_epiwin.first_workspace;
   while(tmp)
   {
      if (tmp == workspace)
      {
	 if (tmp == gl_epiwin.first_workspace)
	    gl_epiwin.first_workspace = tmp->next;
	 if (tmp->prev)
	    tmp->prev->next = tmp->next;
	 if (tmp->next)
	    tmp->next->prev = tmp->prev;
	 free(tmp);		/* free_workspace_window */
      }
      else
	 tmp = tmp->next;
   }
}	  

/*
 ** Give the nth element of the workspace
 */
t_workspace	*workspace_nth(n)
int		n;
{
   t_workspace	*workspace;
   
   workspace = gl_epiwin.first_workspace;
   while ((n-- > 0) && workspace->next)
      workspace = workspace->next;
   if (workspace->nb == n)
      return (workspace);
   else
      return (NULL);
}








