/*
 **  EPIwm
 **  Copyright (C) 1999 Julien Mulot, Thomas Poindessous, Stephane Rault
 **
 **  This program is free software; you can redistribute it and/or modify
 **  it under the terms of the GNU General Public License as published by
 **  the Free Software Foundation; either version 2 of the License, or
 **  (at your option) any later version.
 **
 **  This program is distributed in the hope that it will be useful,
 **  but WITHOUT ANY WARRANTY; without even the implied warranty of
 **  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 **  GNU General Public License for more details.
 **
 **  You should have received a copy of the GNU General Public License
 **  along with this program; if not, write to the Free Software
 **  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 **
 ** workspace_window_list.c
 ** 
 ** Made by (Poindessous Thomas)
 ** Login   <poinde_t@epita.fr>
 ** 
 ** Started on  Wed Mar 31 21:13:11 1999 Poindessous Thomas
 ** Last update Mon May 10 20:15:14 1999 Poindessous Thomas
 */

#include "epiwm.h"

/*
 ** Create a new list and init it to NULL
 */
void			workspace_window_new(workspace, win_group)
t_workspace		*workspace;
t_win			*win_group;
{
   t_workspace_window	*new_workspace_window;
   t_workspace_window	*last;
   
   new_workspace_window = malloc(sizeof(t_workspace_window));
   new_workspace_window->window_group = win_group;
   new_workspace_window->icon = NULL;
   new_workspace_window->is_win_mapped = 1;
   new_workspace_window->is_icon_mapped = 0;
   new_workspace_window->next = NULL;
   new_workspace_window->prev = NULL;
   last = workspace->workspace_window;
   if (last)
   {
      while (last->next)
	 last = last->next;
      new_workspace_window->prev = last;
      last->next = new_workspace_window;
   }
   else
      workspace->workspace_window = new_workspace_window;
}

/*
 ** Free the workspace_window list (totale)
 */
void			workspace_window_free(workspace)
t_workspace		*workspace;
{
   t_workspace_window	*tmp;
   
   tmp = workspace->workspace_window;
   if (tmp->next)
      tmp = tmp->next;
   while (tmp->next)
   {
      free(tmp->prev);		/* free_workspace_window_win->window_group */
      tmp = tmp->next;
   }
   free(tmp);			/* free_workspace_window_win->window_group */
}

/*
 ** Remove an element from the workspace_window (search by data)
 */
void			workspace_window_remove(workspace, workspace_window)
t_workspace		*workspace;
t_workspace_window	*workspace_window;
{
   t_workspace_window	*tmp;
   
   tmp = workspace->workspace_window;
   while(tmp)
     {
	if (tmp == workspace_window)
	  {
	     if (tmp == workspace->workspace_window)
	       workspace->workspace_window = tmp->next;
	     if (tmp->prev)
	       tmp->prev->next = tmp->next;
	     if (tmp->next)
	       tmp->next->prev = tmp->prev;
	     free(tmp);		/* free_workspace_window */
	     tmp = NULL;
	  }
	else
	  tmp = tmp->next;
     }
}	  

t_workspace_window	*workspace_window_search(workspace, win_group)
t_workspace		*workspace;
t_win			*win_group;
{
   t_workspace_window	*tmp;
   
   tmp = workspace->workspace_window;
   while (tmp && !workspace_window_comp(tmp, win_group))
     tmp = tmp->next;
   if (workspace_window_comp(tmp, win_group))
     return (tmp);
   else
     return (NULL);
}

int			workspace_window_comp(tmp, win_group)
t_workspace_window	*tmp;
t_win			*win_group;
{
   if (tmp)
     if (tmp->window_group == win_group)
       return (1);  
   return (0);
}







